;============================================
; Hex File Viewer
;
; PROBLEM: Program blows up (Windows exception
; after attempting to read a file.
;
; See MainWinProc() for gory details.
;============================================

.386
.model flat, stdcall
option casemap :none


.nolist
	include \masm32\include\windows.inc
	include \masm32\include\user32.inc
	include \masm32\include\kernel32.inc
	include \masm32\include\gdi32.inc
	include \masm32\include\comctl32.inc
	include \masm32\include\comdlg32.inc
	include \masm32\include\masm32.inc

	includelib \masm32\lib\gdi32.lib
	includelib \masm32\lib\user32.lib
	includelib \masm32\lib\kernel32.lib
	includelib \masm32\lib\Comctl32.lib
	includelib \masm32\lib\comdlg32.lib
	includelib \masm32\lib\shell32.lib
	includelib \masm32\lib\oleaut32.lib
	includelib \masm32\lib\ole32.lib
	includelib \masm32\lib\masm32.lib
	includelib \masm32\lib\msvcrt.lib
.list


;============================================
; Defines, macros, prototypes, etc.
;============================================

WinMain			PROTO :DWORD
OpenFileDlg		PROTO :HWND, :DWORD

$mainWinWidth		EQU 450
$mainWinHeight		EQU 400
$viewWinX		EQU 25
$viewWinY		EQU 50
$viewWinWidth		EQU $charCellWidth * $numCharCellsX
$viewWinHeight		EQU $charCellHeight * $numCharCellsY

$numCharCellsX		EQU 20
$numCharCellsY		EQU 10
$charCellWidth		EQU 20
$charCellHeight		EQU 25

$startChar		EQU 1
$maxFontVpos		EQU 3
$maxChar		EQU 255			;Highest displayable character value

;===== Window styles: =====
$mainWinAttrs		EQU WS_OVERLAPPEDWINDOW OR WS_CLIPCHILDREN
$fontWinAttrs		EQU WS_CHILD OR WS_VISIBLE OR WS_BORDER OR WS_VSCROLL

;===== Menu items: =====
$menuOpen		EQU 1000
$menuExit		EQU 1010

$fileOpenStrLen		EQU 260


;============================================
; DATA
;============================================
.data

;=====  Handles to various stuff:  =====
InstanceHandle		HWND ?
MainWinHandle		HWND ?
ViewWinHandle		HWND ?

FileHandle		HANDLE ?
HeapHandle		HANDLE ?

MainClassName		DB "HexView", 0
ViewClassName		DB "Viewer", 0

MainDisplayName		DB "Hex File Viewer", 0

StartChar		DW $startChar

FileOpenDlgTitle	DB "Pick file to View:", 0
FileStartPathStr	DB ".\*.*", 0

FileOpenOKMsg		DB "File opened successfully.", 0
InfoCaption		DB "Information", 0

FileOpenErrMsg		DB "Sorry, couldn't open that file.", 0
ErrorCaption		DB "Error Message", 0


failmsg1		DB "Child window creation failed!", 0
failmsg2		DB "RegisterClass() failed!", 0
heremsg			DB "I are here", 0
numoutmsg		DB "###"
numoutarea		DB "#", 0
fileshowmsg		DB "File contents: "
fileshowarea		DB "xxxxxxxxxx", 0
beforeallocmsg		db "Before allocation:", 0
afterallocmsg		db "After allocation:", 0
filesizemsg		DB "File size: %lu", 0
memokmsg		DB "Memory allocated OK", 0
memfailmsg		DB "Memory allocation failed!", 0
readfailmsg		DB "File read failed!", 0


;============================================
; CODE
;============================================
.code


start:
	INVOKE	GetModuleHandle, NULL
	MOV	InstanceHandle, EAX
	INVOKE	WinMain, EAX
	INVOKE	ExitProcess, EAX


;============================================

WinMain		PROC hInst:DWORD
	LOCAL	wc:WNDCLASSEX, msg:MSG, wX:DWORD, wY:DWORD
	LOCAL	scrollInfo:SCROLLINFO, hMenu:HMENU

; Register class for parent window:
	MOV	wc.cbSize, SIZEOF WNDCLASSEX
	MOV	wc.style,  CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
	MOV	wc.lpfnWndProc, OFFSET MainWinProc
	MOV	wc.cbClsExtra, NULL
	MOV	wc.cbWndExtra, NULL
	MOV	EAX, hInst
	MOV	wc.hInstance, EAX
	MOV	wc.hbrBackground, COLOR_BTNFACE+1
	MOV	wc.lpszMenuName,  NULL
	MOV	wc.lpszClassName, OFFSET MainClassName
	MOV	wc.hIcon, NULL
	INVOKE	LoadCursor, NULL, IDC_ARROW
	MOV	wc.hCursor, EAX
	MOV	wc.hIconSm, 0
	INVOKE	RegisterClassEx, ADDR wc
if 0
; Now register class for view window:
	MOV	wc.cbSize, SIZEOF WNDCLASSEX
	MOV	wc.style,  CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
	MOV	wc.lpfnWndProc, OFFSET ViewWinProc
	MOV	wc.cbClsExtra, NULL
	MOV	wc.cbWndExtra, NULL
	MOV	EAX, hInst
	MOV	wc.hInstance, EAX
	MOV	wc.hbrBackground, COLOR_WINDOW+1
	MOV	wc.lpszMenuName,  NULL
	MOV	wc.lpszClassName, OFFSET ViewClassName
	MOV	wc.hIcon, NULL
	INVOKE	LoadCursor, NULL, IDC_ARROW
	MOV	wc.hCursor, EAX
	MOV	wc.hIconSm, 0
	INVOKE	RegisterClassEx, ADDR wc
endif
	INVOKE	GetSystemMetrics, SM_CXSCREEN
	MOV	EDX, $mainWinWidth
	CALL	CenterDim
	MOV	wX, EAX
	INVOKE	GetSystemMetrics, SM_CYSCREEN
	MOV	EDX, $mainWinHeight
	CALL	CenterDim
	MOV	wY, EAX
; Load menu from resource in .exe:
	INVOKE	LoadMenu, hInst, 600		; menu ID
	MOV	hMenu, eax


; Create our main window:
	INVOKE	CreateWindowEx, WS_EX_OVERLAPPEDWINDOW, ADDR MainClassName, ADDR MainDisplayName,
		$mainWinAttrs, wX, wY, $mainWinWidth, $mainWinHeight,
		NULL, hMenu, hInst, NULL
	MOV	MainWinHandle, EAX
	INVOKE	SetMenu, MainWinHandle, hMenu
	INVOKE	ShowWindow, MainWinHandle, SW_SHOWNORMAL
if 0
; Create view window:
	INVOKE	CreateWindowEx, WS_EX_WINDOWEDGE, ADDR FontClassName, NULL,
		$fontWinAttrs, $viewWinX, $viewWinY, $viewWinWidth, $viewWinHeight,
		MainWinHandle, NULL, hInst, NULL
	MOV	ViewWinHandle, EAX
	MOV	scrollInfo.cbSize, SIZEOF SCROLLINFO
	MOV	scrollInfo.fMask, SIF_ALL
	MOV	scrollInfo.nMin, 0
	MOV	scrollInfo.nMax, 6
	MOV	scrollInfo.nPage, 3
	MOV	scrollInfo.nPos, 0
	INVOKE	SetScrollInfo, FontWinHandle, SB_VERT, ADDR scrollInfo, TRUE
	INVOKE	ShowWindow, FontWinHandle, SW_SHOWNORMAL
endif

; Get handle to heap memory to allocate later:
	INVOKE	GetProcessHeap
	MOV	HeapHandle, EAX
;============= Message loop ===================
msgloop:
	INVOKE	GetMessage, ADDR msg, NULL, 0, 0
	OR	EAX, EAX
	JZ	exit
	INVOKE	TranslateMessage, ADDR msg
	INVOKE	DispatchMessage, ADDR msg
	JMP	msgloop

exit:	MOV	EAX, msg.wParam
	RET

WinMain	ENDP


;====================================================================
; Main Window Proc
;====================================================================

MainWinProc	PROC hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	LOCAL	fileOpenName[260]:BYTE, fileSize:DWORD, heapPtr:DWORD
	LOCAL	buffer[100]:BYTE, numBytesRead:DWORD

	MOV	EAX, uMsg
	CMP	EAX, WM_COMMAND
	JE	docmd
	CMP	EAX, WM_CLOSE
	JE	doexit

dodefault:
; use DefWindowProc for all other messages:
	INVOKE	DefWindowProc, hWin, uMsg, wParam, lParam
	RET

doexit:
	INVOKE	PostQuitMessage, NULL
	MOV	EAX, TRUE
	RET

docmd:
	MOV	AX, WORD PTR wParam
	CMP	AX, $menuOpen
	JE	do_open
	CMP	AX,  $menuExit
	JNE	dodefault
	JMP	doexit

do_open:
	MOV	heapPtr, NULL
	INVOKE	OpenFileDlg, hWin, ADDR fileOpenName
; Look at result from GetOpenFileName() to see if user selected a file
; (result will be zero if user cancels, doesn't select a file or an error occurs):
	OR	EAX, EAX
	JZ	open10
	INVOKE	CreateFile, ADDR fileOpenName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL, NULL
; See if file open succeeded:
	CMP	EAX, INVALID_HANDLE_VALUE
	JNE	open20
	INVOKE	MessageBox, hWin, ADDR FileOpenErrMsg, ADDR ErrorCaption, MB_OK
open10:	JMP	open90

open20:	MOV	FileHandle, EAX
	INVOKE	GetFileSize, FileHandle, NULL
	MOV	fileSize, EAX
	add	eax, 1000			;desperate attempt to fix ...
	INVOKE	HeapAlloc, HeapHandle, 0,  eax
; Check that memory allocation succeeded:
	OR	EAX, EAX
	JNZ	open30
	invoke	MessageBox, hWin, memfailmsg, addr ErrorCaption, MB_OK
	jmp	closeit

open30:
	MOV	heapPtr, EAX			;Save pointer to allocated heap
	INVOKE	ReadFile, FileHandle, heapPtr, 20, ADDR numBytesRead, NULL
if 0
	push	eax
	invoke	MessageBox, hWin, addr heremsg, NULL, MB_OK
	pop	eax
endif
	OR	EAX, EAX
	JNZ	open40
	invoke	MessageBox, hWin, ADDR readfailmsg, ADDR ErrorCaption, MB_OK
	jmp	short open90

open40:
;**************************************************************************
; THIS IS WHERE IT ALL BLOWS UP!
;
; Up to now, everything cool. File gets opened, size gotten, and read.
; As soon as any access into the heap buffer is made (in code below),
; BOOM! (The heap can be correctly accessed if ReadFile() is not called.)
;**************************************************************************
	push	esi
	push	edi
	mov	esi, heapPtr
	mov	edi, offset fileshowarea
	mov	ecx, 10
	rep	movsb
	pop	edi
	pop	esi

	invoke	MessageBox, hWin, fileshowmsg, addr InfoCaption, MB_OK
	
closeit:
	INVOKE	CloseHandle, FileHandle
open80:	CMP	heapPtr, NULL
	JNZ	open90
	INVOKE	HeapFree, HeapHandle, 0, heapPtr
open90:	XOR	EAX, EAX
	RET



MainWinProc	ENDP

if 0
;====================================================================
; View Window Proc
;====================================================================

ViewWinProc	PROC hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	LOCAL	paintRect:RECT, paintStruct:PAINTSTRUCT, hDC:HDC
	LOCAL	charOut:BYTE

	MOV	EAX, uMsg
	CMP	EAX, WM_PAINT
	JE	fw_paint
	CMP	EAX, WM_VSCROLL
	JE	fw_scroll
	CMP	EAX, WM_CLOSE
	JE	fw_close


; use DefWindowProc for all other messages:
fw_default:
	INVOKE	DefWindowProc, hWin, uMsg, wParam, lParam
	RET

fw_close:
	INVOKE	PostQuitMessage, NULL
	MOV	EAX, TRUE
	RET

fw_scroll:
	MOV	EAX, wParam
	AND	EAX, 0FFFFH			;Mask off low word (scroll message)
	CMP	EAX, SB_LINEDOWN
	JE	fe_scroll1down
	CMP	EAX, SB_LINEUP
	JNE	fw_default
; User clicked up button:
	CMP	FontVpos, 0			;Already @ top?
	JE	fw_default			;Yes, do nothing.
	DEC	FontVpos
	SUB	StartChar, $numCharCellsX
	JMP	short fw_doscroll

fe_scroll1down:
	INC	FontVpos
	ADD	StartChar, $numCharCellsX
fw_doscroll:
	INVOKE	SetScrollPos, hWin, SB_VERT, FontVpos, TRUE
	INVOKE	InvalidateRect, hWin, NULL, TRUE
	XOR	EAX, EAX
	RET

fw_paint:
	INVOKE	BeginPaint, hWin, ADDR paintStruct
	MOV	hDC, EAX			;Save handle to DC
        INVOKE	GetClientRect, hWin, ADDR paintRect

; Draw grid: horiz. first:
	PUSH	EBX
	MOV	ECX, $numCharCellsY - 1
fdg10:	MOV	EAX, ECX
	MOV	EDX, $charCellHeight
	MUL	EDX
	MOV	EBX, EAX
	PUSH	ECX
	INVOKE	MoveToEx, hDC, 0, EBX, NULL
	INVOKE	LineTo, hDC, $fontWinWidth, EBX
	POP	ECX
	LOOP	fdg10

	MOV	ECX, $numCharCellsX - 1
fdg30:	MOV	EAX, ECX
	MOV	EDX, $charCellWidth
	MUL	EDX
	MOV	EBX, EAX
	PUSH	ECX
	INVOKE	MoveToEx, hDC, EBX, 0, NULL
	INVOKE	LineTo, hDC, EBX, $fontWinHeight
	POP	ECX
	LOOP	fdg30
	POP	EBX

; Put text characters in grid:
	PUSH	ESI
	MOV	AX, StartChar
	MOV	charOut, AL
	XOR	ESI,  ESI			;ESI = row #
	MOV	ECX, $numCharCellsY		;FOR (# cells high)
fdg40:	PUSH	ECX
	MOV	EAX, $charCellHeight
	MUL	ESI
	MOV	paintRect.top, EAX
	ADD	EAX, $charCellHeight
	MOV	paintRect.bottom, EAX
	XOR	EAX, EAX
	MOV	paintRect.left, EAX
	ADD	EAX, $charCellWidth
	MOV	paintRect.right,  EAX
	MOV	ECX, $numCharCellsX		;FOR (# cells across)
fdg45:	PUSH	ECX	
	INVOKE	DrawText, hDC, ADDR charOut, 1, ADDR paintRect, DT_BOTTOM OR DT_CENTER OR DT_SINGLELINE OR DT_NOPREFIX
	POP	ECX
	INC	charOut
	MOV	EAX, $charCellWidth
	ADD	paintRect.left, EAX
	ADD	paintRect.right, EAX
	LOOP	fdg45
	POP	ECX
	INC	ESI
	DEC	ECX				;Next row
	JCXZ	fdg99
	JMP	fdg40
fdg99:	POP	ESI

	INVOKE	EndPaint, hDC, ADDR paintStruct

	XOR	EAX, EAX
	RET



ViewWinProc	ENDP
endif



OpenFileDlg	PROC	hWin:HWND, fileOpenNamePtr:DWORD
	LOCAL	ofn:OPENFILENAME
	local	buffer[40]:byte

; First, zero out entire structure:
	PUSH	EDI
	LEA	EDI, ofn
	MOV	ECX, SIZEOF OPENFILENAME
	XOR	EAX, EAX
	REP	STOSB					;Zero it out.
	POP	EDI

	MOV	ofn.lStructSize, SIZEOF OPENFILENAME
	MOV	EAX, hWin
	MOV	ofn.hWndOwner, EAX
	MOV	EAX, InstanceHandle
	MOV	ofn.hInstance, EAX
	MOV	EAX, fileOpenNamePtr
	MOV	ofn.lpstrFile, EAX
	PUSH	ESI
	PUSH	EDI
	LEA	ESI, FileStartPathStr
	MOV	EDI, EAX				;EAX = fileOpenNamePtr
	CALL	strcpy
	POP	EDI
	POP	ESI
	MOV	ofn.nMaxFile, $fileOpenStrLen
	MOV	ofn.lpstrTitle, OFFSET FileOpenDlgTitle
	MOV	ofn.Flags, OFN_EXPLORER OR OFN_FILEMUSTEXIST OR OFN_LONGNAMES OR OFN_HIDEREADONLY
	INVOKE	GetOpenFileName, ADDR ofn
	
	RET

OpenFileDlg	ENDP



;====================================================================
; CenterDim
;
; Returns half screen dimension (X or Y) minus half window dimension
;
; On entry,
;	EAX = screen dimension
;	EDX = window dimension
;
; Returns:
;	sdim/2 - wdim/2
;====================================================================

CenterDim	PROC

	SHR	EAX, 1				;divide screen dimension by 2
	SHR	EDX, 1				;divide window dimension by 2
	SUB	EAX, EDX
	RET					;Return w/# in EAX

CenterDim	ENDP


;====================================================================
; B2A4
;
; Converts binary value to ASCII numeric digits (4 digits, limited to
; maximum value of 9999). Result is leading-zero suppressed.
;
; On entry,
;	EAX = value to convert
;	EDI--> END of location to store digits (4)
;
; Returns: (nothing)
;
;====================================================================

B2A4		PROC
; *** Code courtesy of "dedndave" from The MASM Forum  ***

	MOV	ECX, 4			;4 digits
	JMP	SHORT b2a11
b2a10:	OR	EAX, EAX
        JZ      b2a12			;If # is zero, just put in one '0'.
b2a11:	PUSH	ECX
	MOV	CL, 10
	XOR	EDX, EDX
	DIV	ECX
	OR	DL, '0'			;Binary--> ASCII
	POP	ECX
	MOV	[EDI], DL
	DEC	EDI
	LOOP	b2a10
	RET

b2a12:	MOV	BYTE PTR [EDI],  ' '
	DEC	EDI
	LOOP	b2a12
	RET

B2A4		ENDP


strcpy		PROC

scp10:	MOV	AL, BYTE PTR [ESI]
	MOV	[EDI], BYTE PTR AL
	OR	AL, AL			;Stop on NULL.
	JZ	scp99
	INC	ESI
	INC	EDI
	JMP	scp10

scp99:	RET

strcpy		ENDP




END	start

